<template>
  <div @click="onClose" :class="{screen: true, opened}"></div>
  <div :class="{library: true, opened}">
    <div class="list">
      <div class="item" v-for="(section, index) in sections" :key="index" @click="()=>{selectItem(section.key)}">
        <span>{{section.label || section.key}}</span>
        <img class="image" :src="`/images/svg/components/${section.image}.svg`" alt="">
      </div>
    </div>
  </div>
</template>

<script>
import site_components from "sc/index";

export default {
  components: {
    ...site_components.sections
  },
  props:["opened", "onClose", "onChoose"],
  setup(){
    return {
      sections: Object.keys(site_components.sections).map(key=>({image: site_components.sections[key].image, label: site_components.sections[key].label, key}))
    }
  },
  methods: {
    selectItem(name){
      this.onChoose(name);
      this.onClose();
    }
  }
};
</script>

<style scoped lang="scss">
.library {
  z-index: 8;
  padding: 8px;
  position: fixed;
  left: 44px;
  top: 44px;
  height: calc(100vh - 44px);
  background: #FFFFFF;
  width: 300px;
  transform: translateX(-100%);
  transition: 0.3s ease all;

  &.opened{
    transform: translateX(0);
  }
}

.navBarExpanded{
  .library{
    left: 200px;
  }
}

.screen{
  z-index: 7;
  position: fixed;
  top: 0;
  bottom: 0;
  left: 0; 
  right: 0;
  background: #00000040;
  opacity: 0;
  transition: 0.3s ease all;
  pointer-events: none;
  &.opened{
    opacity: 1;
    pointer-events: all;
  }
}


.list{
  display: flex;
  flex-direction: column;

  .item{
    width: 100%;
    border: none;
    outline: none;
    padding: 0px;
    background: #ffffff;
    border-radius: 4px;
    font-size: 18px;
    overflow: hidden;
    box-shadow: 0 2px 4px #00000050;

    .image{
      display: block;
      width: 100%;
    }

    &:not(:last-child){
      margin-bottom: 16px;
    }

    span{
      display: block;
      padding: 8px 16px;
    }

    &:hover{
      box-shadow: 0 0 4px #00000090;
    }

    &:active{
      box-shadow: 0 0 4px #00000090;
    }
  }
}

.title{
  color: var(--primary-color);
}
</style>
